package de.hpi.imdbsuche.entities.imdb;

import java.sql.ResultSet;
import java.sql.SQLException;

import de.hpi.imdbsuche.entities.DBEntity;

public class Genre implements DBEntity {
	
	public static final String TABLE_NAME = "genre";
	
	public static final String SQL_CREATE_TABLE = "CREATE TABLE genre ("
													+ "id INTEGER PRIMARY KEY,"
													+ "movie_id VARCHAR(127),"
													+ "genre VARCHAR(127))";

	public static final String SQL_INSERT_INTO = "INSERT INTO genre(id,movie_id,genre) VALUES(?,?,?)";

	private final int id;
	
	private final String movieId;
	
	private final String genre;
	
	public int getId() {
		return this.id;
	}

	public String getMovieId() {
		return this.movieId;
	}

	public String getGenre() {
		return this.genre;
	}

	@Override
	public String getTableName() {
		return TABLE_NAME;
	}

	@Override
	public String getCreateTableSql() {
		return SQL_CREATE_TABLE;
	}

	@Override
	public String getInsertIntoSql() {
		return SQL_INSERT_INTO;
	}

	public Genre(ResultSet rs) throws SQLException {
		this(	rs.getInt("id"),
				rs.getString("movie_id"), 
				rs.getString("genre"));
	}
	
	public Genre(int id, String movieId, String genre) {
		this.id = id;
		this.movieId = movieId;
		this.genre = genre;
	}

	public Genre() {
		this.id = 0;
		this.movieId = null;
		this.genre = null;
	}
	
	@Override
	public String toString() {
		return "Genre[" + this.id + ", " + this.movieId + ", " + this.genre + "]";
	}
}
