package de.hpi.imdbsuche.entities.imdb;

import java.sql.ResultSet;
import java.sql.SQLException;

import de.hpi.imdbsuche.entities.DBEntity;

public class Movie implements DBEntity {

	public static final String TABLE_NAME = "movie";
	
	public static final String SQL_CREATE_TABLE = "CREATE TABLE movie ("
													+ "mid VARCHAR(127) PRIMARY KEY,"
													+ "title VARCHAR(127),"
													+ "year INTEGER)";

	public static final String SQL_INSERT_INTO = "INSERT INTO movie(mid,title,year) VALUES(?,?,?)";

	private final String mid;
	
	private final String title;
	
	private final int year;
	
	public String getMid() {
		return this.mid;
	}

	public String getTitle() {
		return this.title;
	}

	public int getYear() {
		return this.year;
	}

	@Override
	public String getTableName() {
		return TABLE_NAME;
	}

	@Override
	public String getCreateTableSql() {
		return SQL_CREATE_TABLE;
	}

	@Override
	public String getInsertIntoSql() {
		return SQL_INSERT_INTO;
	}

	public Movie(ResultSet rs) throws SQLException {
		this(	rs.getString("mid"), 
				rs.getString("title"),
				rs.getInt("year"));
	}
	
	public Movie(String mid, String title, int year) {
		this.mid = mid;
		this.title = title;
		this.year = year;
	}

	public Movie() {
		this.mid = null;
		this.title = null;
		this.year = 0;
	}
	
	@Override
	public String toString() {
		return "Movie[" + this.mid + ", " + this.title + ", " + this.year + "]";
	}
}
