package de.hpi.imdbsuche.entities.imdb;

import java.sql.ResultSet;
import java.sql.SQLException;

import de.hpi.imdbsuche.entities.DBEntity;

public class Producer implements DBEntity {

	public static final String TABLE_NAME = "producer";
	
	public static final String SQL_CREATE_TABLE = "CREATE TABLE producer ("
													+ "id INTEGER PRIMARY KEY,"
													+ "name VARCHAR(127),"
													+ "movie_id VARCHAR(127),"
													+ "role VARCHAR(127))";

	public static final String SQL_INSERT_INTO = "INSERT INTO producer(id,name,movie_id,role) VALUES(?,?,?,?)";

	private final int id;
	
	private final String name;
	
	private final String movieId;
	
	private final String role;
	
	public int getId() {
		return this.id;
	}

	public String getName() {
		return this.name;
	}

	public String getMovieId() {
		return this.movieId;
	}

	public String getRole() {
		return this.role;
	}

	@Override
	public String getTableName() {
		return TABLE_NAME;
	}

	@Override
	public String getCreateTableSql() {
		return SQL_CREATE_TABLE;
	}

	@Override
	public String getInsertIntoSql() {
		return SQL_INSERT_INTO;
	}

	public Producer(ResultSet rs) throws SQLException {
		this(	rs.getInt("id"), 
				rs.getString("name"), 
				rs.getString("movie_id"), 
				rs.getString("role"));
	}
	
	public Producer(int id, String name, String movieId, String role) {
		this.id = id;
		this.name = name;
		this.movieId = movieId;
		this.role = role;
	}

	public Producer() {
		this.id = 0;
		this.name = null;
		this.movieId = null;
		this.role = null;
	}
	
	@Override
	public String toString() {
		return "Producer[" + this.id + ", " + this.name + ", " + this.movieId + ", " + this.role + "]";
	}
}
